﻿namespace MVCDemo.Controllers
{
    using System;
    using System.Web.Mvc;
    using MVCDemo.Models;
    using MVCDemo.Models.Binders;

    public class PaymentsController : Controller
    {

        // GET: /Payments/
        public ActionResult Index()
        {
            this.ViewBag.Message = this.TempData["Message"];

            var paymentsRepository = new PaymentRepository();
            return View(paymentsRepository.Payments);
        }

        // GET: /Payments/Add/
        public ActionResult Add()
        {
            return View(new PaymentModel());
        }

        // POST: /Payments/Add/
        [HttpPost]
        public ActionResult Add(PaymentModel newPayment)
        {
            if (!this.ModelState.IsValid) {
                return this.View(newPayment);
            }

            var paymentsRepository = new PaymentRepository();
            paymentsRepository.Add(newPayment, PaymentModel.PaymentSource.Direct);

            this.TempData["Message"] = Resources.Controllers.PaymentsRes.PaymentAddedMessage;

            return this.RedirectToAction("Index");
        }

        // POST: /Payments/IsLoginNotExists/
        [HttpPost]
        public JsonResult IsLoginNotExists(string userLogin)
        {
            var userRepository = new UserRepository();

            return this.Json(userRepository.IsLoginExists(userLogin));
        }

        // GET: /Payments/GlobalBankOne/
        public ActionResult GlobalBankOne(
            [ModelBinder(typeof(GlobalBankOneBinder))] PaymentModel newPayment)
        {
            if (!this.ModelState.IsValid) {
                return this.View("Add", newPayment);
            }

            var paymentsRepository = new PaymentRepository();
            paymentsRepository.Add(newPayment);

            this.TempData["Message"] = Resources.Controllers.PaymentsRes.PaymentAddedMessage;

            return this.RedirectToAction("Index");
        }
    }
}