﻿namespace MVCDemo.Controllers
{
    using System.Web.Mvc;
    using MVCDemo.Models;
    using System;

    public class UserProfilesController : Controller
    {
        // GET: /UserProfiles/
        // GET: /UserProfiles/Index/
        public ActionResult Index()
        {
            this.ViewBag.Message = this.TempData["Message"];

            var userRepository = new UserRepository();
            return this.View(userRepository.Profiles);
        }

        // GET: /UserProfiles/Create/
        public ActionResult Create()
        {
            return this.View(new NewUserProfileModel());
        }

        // POST: /UserProfiles/Create/
        [HttpPost]
        public ActionResult Create(NewUserProfileModel newUserProfile)
        {
            if (!this.ModelState.IsValid) {
                return this.View(newUserProfile);
            }

            var userRepository = new UserRepository();
            userRepository.Add(newUserProfile);

            this.TempData["Message"] = Resources.Controllers.UserProfilesRes.ProfileCreatedMessage;

            return this.RedirectToAction("Index");
        }

        // POST: /UserProfiles/IsLoginExists/
        [HttpPost]
        public JsonResult IsLoginExists(string login)
        {
            var userRepository = new UserRepository();
            bool isExist = userRepository.IsLoginExists(login);
            return this.Json(!isExist);
        }
    }
}