﻿namespace MVCDemo.Models.Binders
{
    using System;
    using System.Web.Mvc;
    using MVCDemo.Resources.Models;
    using MVCDemo.Resources.Shared;

    public class GlobalBankOneBinder : IModelBinder
    {
        #region IModelBinder Members

        public object BindModel(
            ControllerContext controllerContext, ModelBindingContext bindingContext)
        {
            var payment = new PaymentModel();

            payment.UserLogin = controllerContext.HttpContext.Request["user"];
            var userRepository = new UserRepository();
            if (!userRepository.IsLoginExists(payment.UserLogin)) {
                bindingContext.ModelState.AddModelError("UserLogin", ErrorsRes.InvalidUserLogin);
            }

            payment.Date = DateTime.Now;

            try {
                payment.Amount
                    = Convert.ToDouble(controllerContext.HttpContext.Request["money"]);
            }
            catch {
                bindingContext.ModelState.AddModelError(
                    "Amount", PaymentRes.IncorrectAmountValue);
            }

            payment.Source = PaymentModel.PaymentSource.GlobalBankOne;

            payment.Info = controllerContext.HttpContext.Request["additionalinfo"];

            return payment;
        }

        #endregion
    }
}