﻿/// Copyright (c) 2011 Andrey Veselov. All rights reserved.
/// WebSite: http://andrey.moveax.ru 
/// Email: andrey@moveax.ru
/// This source is subject to the Microsoft Public License (Ms-PL).

namespace MVCDemo.Models.Configuration.Rules
{
    using System;
    using System.IO;
    using System.Web.Mvc;
    using System.Xml.Linq;
    using MVCDemo.Attributes.Validation;
    using MVCDemo.Models.Extensions;

    public class EqualRule : ModelValidatorRule
    {
        public override ModelValidator Create(
            XElement xmlElement, Type defaultResourceType, ModelMetadata metadata, ControllerContext context)
        {
            string value = xmlElement.GetValueOrNull("value");
            if (value == null) {
                throw new InvalidDataException(
                    string.Format("The value was not set. Element: {0}", xmlElement));
            }

            string type = xmlElement.GetValueOrNull("type");
            if (value == null) {
                type = "System.Boolean";
            }

            var objectValue = Convert.ChangeType (value, Type.GetType(type, throwOnError: true));

            var attribute = new EqualAttribute(objectValue);
            this.BindErrorMessageToAttribte(attribute, xmlElement, defaultResourceType);

            return new DataAnnotationsModelValidator<EqualAttribute>(metadata, context, attribute);
        }
    }
}