﻿/// Copyright (c) 2011 Andrey Veselov. All rights reserved.
/// WebSite: http://andrey.moveax.ru 
/// Email: andrey@moveax.ru
/// This source is subject to the Microsoft Public License (Ms-PL).

namespace MVCDemo.Models.Configuration.Rules
{
    using System;
    using System.ComponentModel.DataAnnotations;
    using System.Web.Mvc;
    using System.Xml.Linq;
    using MVCDemo.Models.Extensions;

    public abstract class ModelValidatorRule : IModelValidatorRule
    {
        public abstract ModelValidator Create(
            XElement xmlElement, Type defaultResourceType, ModelMetadata metadata, ControllerContext context);

        protected void BindErrorMessageToAttribte(
            ValidationAttribute attribute, XElement xmlElement, Type defaultResourceType)
        {
            string errorMessage = xmlElement.GetValueOrNull("errormessage");
            if (errorMessage != null) {
                attribute.ErrorMessage = errorMessage;
                return;
            }

            string errorMessageResName = xmlElement.GetValueOrNull("resname");
            if (errorMessageResName != null) {
                attribute.ErrorMessageResourceName = errorMessageResName;

                string errorMessageResType = xmlElement.GetValueOrNull("resource");
                attribute.ErrorMessageResourceType =
                    (errorMessageResType != null) ?
                    Type.GetType(errorMessageResType, throwOnError: true) : defaultResourceType;
            }
        }
    }
}