﻿/// Copyright (c) 2011 Andrey Veselov. All rights reserved.
/// WebSite: http://andrey.moveax.ru 
/// Email: andrey@moveax.ru
/// This source is subject to the Microsoft Public License (Ms-PL).

namespace MVCDemo.Models.Configuration.Rules
{
    using System;
    using System.ComponentModel.DataAnnotations;
    using System.IO;
    using System.Web.Mvc;
    using System.Xml.Linq;
    using MVCDemo.Models.Extensions;

    public class RegularExpressionRule : ModelValidatorRule
    {
        public override ModelValidator Create(
            XElement xmlElement, Type defaultResourceType, ModelMetadata metadata, ControllerContext context)
        {
            string regExp = xmlElement.GetValueOrNull("regexp");
            if (regExp == null) {
                throw new InvalidDataException(
                    string.Format("The regular expression was not set. Element: {0}", xmlElement));
            }

            var attribute = new RegularExpressionAttribute(regExp);
            this.BindErrorMessageToAttribte(attribute, xmlElement, defaultResourceType);

            return new RegularExpressionAttributeAdapter(metadata, context, attribute);
        }
    }
}