﻿/// Copyright (c) 2011 Andrey Veselov. All rights reserved.
/// WebSite: http://andrey.moveax.ru 
/// Email: andrey@moveax.ru
/// This source is subject to the Microsoft Public License (Ms-PL).

namespace MVCDemo.Models.Configuration.Rules
{
    using System;
    using System.ComponentModel.DataAnnotations;
    using System.Web.Mvc;
    using System.Xml.Linq;

    public class RequireRule : ModelValidatorRule
    {
        public override ModelValidator Create(
            XElement xmlElement, Type defaultResourceType, ModelMetadata metadata, ControllerContext context)
        {
            metadata.IsRequired = false;

            var attribute = new RequiredAttribute();
            this.BindErrorMessageToAttribte(attribute, xmlElement, defaultResourceType);

            return new RequiredAttributeAdapter(metadata, context, attribute);
        }
    }
}