﻿/// Copyright (c) 2011 Andrey Veselov. All rights reserved.
/// WebSite: http://andrey.moveax.ru 
/// Email: andrey@moveax.ru
/// This source is subject to the Microsoft Public License (Ms-PL).

namespace MVCDemo.Models.Configuration.Rules
{
    using System;
    using System.ComponentModel.DataAnnotations;
    using System.IO;
    using System.Web.Mvc;
    using System.Xml.Linq;
    using MVCDemo.Models.Extensions;

    public class StringLengthRule : ModelValidatorRule
    {
        public override ModelValidator Create(
            XElement xmlElement, Type defaultResourceType, ModelMetadata metadata, ControllerContext context)
        {
            string maxLenght = xmlElement.GetValueOrNull("max");
            if (maxLenght == null) {
                throw new InvalidDataException(
                    string.Format("The maximum string length was not set. Element: {0}", xmlElement));
            }

            var attribute = new StringLengthAttribute(Convert.ToInt32(maxLenght));
            this.BindErrorMessageToAttribte(attribute, xmlElement, defaultResourceType);

            return new StringLengthAttributeAdapter(metadata, context, attribute);
        }
    }
}