﻿/// Copyright (c) 2011 Andrey Veselov. All rights reserved.
/// WebSite: http://andrey.moveax.ru 
/// Email: andrey@moveax.ru
/// This source is subject to the Microsoft Public License (Ms-PL).

namespace MVCDemo.Models.MetadataProviders
{
    using System;
    using System.Collections.Generic;
    using System.Web.Mvc;

    public interface IModelMetadataProvider
    {
        bool IsAbleToProvideMetadata(Type containerType);

        IEnumerable<ModelMetadata> GetMetadataForProperties(
            object container, Type containerType);

        ModelMetadata GetMetadataForProperty(
            Func<object> modelAccessor, Type containerType, string propertyName);

        ModelMetadata GetMetadataForType(
            Func<object> modelAccessor, Type modelType);
    }
}